<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

      <v-container>
      
        <v-row dense >
          <v-col cols="3"><span class="label">Benchmarked resources:</span></v-col>
          <v-col cols="9">{{resources.join(', ')}}</v-col>
        </v-row>
        
        <v-row dense v-if="properties.length">
          <v-col cols="3"><span class="label">Properties:</span></v-col>
          <v-col cols="9">{{properties.join(', ')}}</v-col>
        </v-row>

        <v-row dense v-if="environment.length">
          <v-col cols="3"><span class="label">Environment:</span></v-col>
          <v-col cols="9">{{environment.join(', ')}}</v-col>
        </v-row>

        <v-row dense v-if="item.benchsuite_additional_opts && item.benchsuite_additional_opts.length">
          <v-col cols="3"><span class="label">Benchsuite additional options:</span></v-col>
          <v-col cols="9">{{item.benchsuite_additional_opts.join(', ')}}</v-col>
        </v-row>

        <v-row dense v-if="docker_additional_opts && docker_additional_opts.length">
          <v-col cols="3"><span class="label">Docker additional options:</span></v-col>
          <v-col cols="9">{{docker_additional_opts.join(', ')}}</v-col>
        </v-row>

        <v-row dense>
          <v-col cols="3"><span class="label">Results sharing:</span></v-col>
          <v-col cols="9">{{scope}}</v-col>
        </v-row>
        
        <template v-if="workloadNames && workloadNames.length>0">
          <div>Workloads are: <b>{{workloadNames.join(', ')}}</b></div>
        </template>
        
      </v-container>
  
</template>

<script>

import { getScheduleSharingLevel } from '../common/benchsuite.js';

export default {

 name: 'ScheduleSummary',

  components: {
  },

  props: {
    item: {
      type: Object,
      default: function() {return {}}
    }
  },
  
  data: () => ({
  }),
  
  computed: {
    sharing() {
      return getScheduleSharingLevel(this.item);
    },
    interval() {
      if(this.item && this.item.interval)
        for(var i in this.item.interval)
          return this.item.interval[i];
      return ""
    },
    unit() {
      if(this.item && this.item.interval)
        for(var i in this.item.interval)
          return i;
      return ""
    },
    workloadNames() {
      var out = [];
      for(var i in this.item.workloads) {
        out.push(this.item.workloads[i].workload_name + " (" + this.item.workloads[i].tool_name + ")");      
      }
      return out.sort((a,b) => {return a.toLowerCase() < b.toLowerCase() ? -1 : 1});
    },
    properties() {
      var out = [];
      for(var key in this.item.properties) {
        var value = this.item.properties[key];
        out.push(key+"="+value);
      }
      return out.sort((a,b) => {return a.toLowerCase() < b.toLowerCase() ? -1 : 1});
    },
    environment() {
      var out = [];
      for(var key in this.item.environment) {
        var value = this.item.environment[key];
        out.push(key+"="+value);
      }
      return out.sort((a,b) => {return a.toLowerCase() < b.toLowerCase() ? -1 : 1});
    },
    docker_additional_opts() {
      var out = [];
      for(var key in this.item.docker_additional_opts) {
        var value = this.item.docker_additional_opts[key];
        out.push(key+"="+value);
      }
      return out.sort((a,b) => {return a.toLowerCase() < b.toLowerCase() ? -1 : 1});
    },
    scope() {
      var scope = this.item["reports-scope"];
      if(!scope)
        return "";
      else if(scope.startsWith("usr:"))
        return "Private. Metrics are visibile to you only";
      else if(scope=="org:public")
        return "Public. Metrics are visible to everybody";
      else
        return "Shared. Metrics are visible to all members of organization " + scope.substring(4);
    },
    resources() {
      var res = {}
      for(var i in this.item.service_types) {
        var st = this.item.service_types[i] ;
        if(!res[st.image])
          res[st.image] = [];
        res[st.image].push(st.size);
      }
      var out = []
      for(var k in res) {
        out.push(k + " (" + res[k].join(", ") + ")");
      }
      return out.sort((a,b) => {return a.toLowerCase() < b.toLowerCase() ? -1 : 1});
    }
  }
};

</script>
<style>
span.label {
  color:#00000098;
}

</style>
